{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module Graph where {

import List;
import Util;
import ErrorMonad;
import Show;

checkEdgeLazy ::
  forall a. (Eq a) => ((a, a) -> Bool) -> (a, a) -> [(Bool, [a])] -> Bool;
checkEdgeLazy g (x, y) ((real, c) : cs) =
  member x c && (real && member y c || testPos (\ d -> member y (snd d)) cs) ||
    checkEdgeLazy g (x, y) cs;
checkEdgeLazy g e [] = not (g e);

checkEdgeM ::
  forall a.
    (Eq a) => ((a, a) -> Bool) -> [(Bool, [a])] -> (a, a) -> Eithera (a, a) ();
checkEdgeM g cs e = checkF (\ ea -> checkEdgeLazy g ea cs) id e;

checkSccLazy ::
  forall a.
    (Eq a) => ((a, a) -> Bool) -> [a] -> [(Bool, [a])] -> Eithera (a, a) ();
checkSccLazy g ns cs =
  catcha
    (checkAllMI (checkEdgeM g cs)
      (concata (mapa (\ x -> mapa (\ a -> (x, a)) ns) ns)))
    (\ x -> errora (snd x));

checkDecomposition ::
  forall a.
    (Eq a,
      Sshow a) => ((a, a) -> Bool) ->
                    [a] -> [(Bool, [a])] -> Eithera [[Char]] ();
checkDecomposition g n allSccs =
  bind (catcha (checkPartition (mapa snd allSccs))
         (\ x ->
           errora
             [append "components do not form a partition due to node "
                (sshow x)]))
    (\ x ->
      catcha (checkSccLazy g n allSccs)
        (\ xa -> errora ["the following edge is not covered:", sshowa xa]));

}
